//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private PBF_B_S_Pressure[] cachePBF_B_S_Pressure = null;

        private static PBF_B_S_Pressure checkPBF_B_S_Pressure = new PBF_B_S_Pressure();

        /// <summary>
        /// The PBF Buy Sell Pressure is a real-time indicator and does not plot against historical data.
        /// </summary>
        /// <returns></returns>
        public PBF_B_S_Pressure PBF_B_S_Pressure()
        {
            return PBF_B_S_Pressure(Input);
        }

        /// <summary>
        /// The PBF Buy Sell Pressure is a real-time indicator and does not plot against historical data.
        /// </summary>
        /// <returns></returns>
        public PBF_B_S_Pressure PBF_B_S_Pressure(Data.IDataSeries input)
        {

            if (cachePBF_B_S_Pressure != null)
                for (int idx = 0; idx < cachePBF_B_S_Pressure.Length; idx++)
                    if (cachePBF_B_S_Pressure[idx].EqualsInput(input))
                        return cachePBF_B_S_Pressure[idx];

            PBF_B_S_Pressure indicator = new PBF_B_S_Pressure();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.SetUp();

            PBF_B_S_Pressure[] tmp = new PBF_B_S_Pressure[cachePBF_B_S_Pressure == null ? 1 : cachePBF_B_S_Pressure.Length + 1];
            if (cachePBF_B_S_Pressure != null)
                cachePBF_B_S_Pressure.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cachePBF_B_S_Pressure = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// The PBF Buy Sell Pressure is a real-time indicator and does not plot against historical data.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PBF_B_S_Pressure PBF_B_S_Pressure()
        {
            return _indicator.PBF_B_S_Pressure(Input);
        }

        /// <summary>
        /// The PBF Buy Sell Pressure is a real-time indicator and does not plot against historical data.
        /// </summary>
        /// <returns></returns>
        public Indicator.PBF_B_S_Pressure PBF_B_S_Pressure(Data.IDataSeries input)
        {
            return _indicator.PBF_B_S_Pressure(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// The PBF Buy Sell Pressure is a real-time indicator and does not plot against historical data.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PBF_B_S_Pressure PBF_B_S_Pressure()
        {
            return _indicator.PBF_B_S_Pressure(Input);
        }

        /// <summary>
        /// The PBF Buy Sell Pressure is a real-time indicator and does not plot against historical data.
        /// </summary>
        /// <returns></returns>
        public Indicator.PBF_B_S_Pressure PBF_B_S_Pressure(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PBF_B_S_Pressure(input);
        }

    }
}
#endregion
